<?php

namespace App\Modules\Admin\Controllers\Admin;

use App\Base\BaseController;
use App\Modules\Admin\Services\GoodsService;
use Faker\Provider\Image;

class GoodsController extends BaseController
{
    /** @var GoodsService $service */
    protected $service;

    public function __construct(GoodsService $authService)
    {
        $this->service = $authService;
    }

    public function paginate()
    {

        return $this->ok([
            "total" => 1,
            "page_total" => 1,
            "list" => [
                [
                    "id" => 1,
                    "name" => "商品名称",
                    "thumb" => Image::imageUrl(),
                    "weight" => 1,
                    "status" => 1,
                ],
            ],
        ]);
    }

    public function changeStatus()
    {
//        $id = request()->input("id", 0);
//        $m = Setting::whereType(Setting::TYPE_BANNER)->where("id", $id)->firstOrFail();
//        $value = $m->value ?? [];
//
//        $isUse = 1;
//        if (Arr::get($value, "is_use")) {
//            $isUse = 0;
//        }
//        $value['is_use'] = $isUse;
//        $m->value = $value;
//        $m->save();
        return $this->ok();
    }

    public function makeSkuTable()
    {
        $this->valid([
            "spec_list" => "array",
        ]);

        return $this->ok([
            "sku_table" => [
                [
                    "id" => 0,
                    "sn" => "规格型号",
                    "3d_url" => "",
                    "spec_attr" => [
                        [
                            "id" => 1,
                            "name" => "属性一",
                        ],
                        [
                            "id" => 2,
                            "name" => "属性二",
                        ],
                    ],
                    "is_use" => 1,
                ],
            ],
        ]);
    }

    public function info()
    {
        return $this->ok([
            "id" => 1,
            "image_list" => [
                Image::imageUrl(),
                Image::imageUrl(),
            ],
            "category" => [
                [
                    "id" => 1,
                    "is_public" => 1,
                ],
                [
                    "id" => 2,
                    "is_public" => 0,
                ],
            ],
            "spec" => [
                [
                    "id" => 1,
                ],
            ],
            "sku" => [
                [
                    "id" => 0,
                    "sn" => "规格型号",
                    "3d_url" => "",
                    "spec_attr" => [
                        [
                            "id" => 1,
                            "name" => "属性一",
                        ],
                        [
                            "id" => 2,
                            "name" => "属性二",
                        ],
                    ],
                    "is_use" => 1,
                ],
            ],
            "weight" => 1,
            "desc_html" => "<h1>it's html</h1>",
            "spec_attr_html" => "<h1>it's html</h1>",
            "faq_html" => "<h1>it's html</h1>",
        ]);
    }

    public function store()
    {
        return $this->ok();
    }

    public function specPaginate()
    {
        $data = $this->valid([
            "name" => "",
            "status" => "",
            "page_size" => "",
        ]);

        return $this->ok($this->service->specPaginate($data));
    }

    public function specStore()
    {
        $params = $this->valid([
            "id" => "",
            "name" => "required",
            "attr" => "array",
            "index_weight" => "int",
            "category_weight" => "int",
            "search_weight" => "int",
            "is_custom" => "int",
        ]);

        return $this->ok($this->service->specStore($params));
    }

    public function specInfo()
    {
        $params = $this->valid([
            "id" => "required",
        ]);

        return $this->ok($this->service->specInfo($params));
    }

    public function specDelete()
    {
        $data = $this->valid([
            "id" => "required",
        ]);

        return $this->ok($this->service->specDelete($data));
    }
}
